import { RefObject } from "react";
declare type InitialStateType<T> = {
    [P in keyof T]: string;
};
declare type ReturnType<T> = {
    [P in keyof T]: [string, {
        (newValue: string): void;
    }];
};
export declare const useDataState: <T extends InitialStateType<T>>(initialState: T, ref: RefObject<HTMLElement>) => ReturnType<T>;
export default useDataState;
