"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDataState = void 0;
var react_1 = require("react");
exports.useDataState = function (initialState, ref) {
    var _a = react_1.useState(initialState), state = _a[0], set = _a[1];
    react_1.useEffect(function () {
        var $el = ref.current;
        if ($el) {
            var entries_1 = Object.entries(state);
            entries_1.forEach(function (_a) {
                var key = _a[0], value = _a[1];
                $el.dataset[key.toString()] = value;
            });
        }
    }, [ref.current, state]);
    var genSetter = react_1.useCallback(function (key) { return function (newValue) {
        set(function (prevState) {
            var _a;
            return (__assign(__assign({}, prevState), (_a = {}, _a[key] = newValue, _a)));
        });
    }; }, []);
    var schema = {};
    var entries = Object.entries(state);
    entries.forEach(function (_a) {
        var key = _a[0], value = _a[1];
        schema[key] = [value, genSetter(key)];
    });
    return schema;
};
exports.default = exports.useDataState;
//# sourceMappingURL=useDataState.js.map