import { RefObject } from "react";
declare type KeyValuePair = {
    key: string;
    value: string;
};
declare type ConfigType<T> = {
    [P in keyof T]: string | KeyValuePair;
};
declare type ReturnType<T> = {
    [P in keyof T]: [string, {
        (newValue: string): void;
    }];
};
export declare const useSelectorState: <T extends ConfigType<T>>(config: T, ref?: RefObject<HTMLElement> | undefined) => ReturnType<T>;
export default useSelectorState;
