"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelectorState = void 0;
var react_1 = require("react");
exports.useSelectorState = function (config, ref) {
    var $root;
    var entries = Object.entries(config);
    var getInitialState = function () {
        var initialState = {};
        entries.forEach(function (_a) {
            var prop = _a[0], data = _a[1];
            var key;
            var value;
            if (!$root) {
                initialState[prop] = "";
            }
            else {
                var $styles = getComputedStyle($root);
                if (typeof data === "string") {
                    key = data;
                    value = $styles.getPropertyValue(data);
                }
                else {
                    key = data.key;
                    value = data.value;
                }
                initialState[prop] = value.trim();
                $root.style.setProperty(key, initialState[prop]);
            }
        });
        return initialState;
    };
    var initialState = getInitialState();
    var _a = react_1.useState(initialState), state = _a[0], set = _a[1];
    react_1.useEffect(function () {
        $root = (ref
            ? ref.current
            : document.querySelector(":root"));
        var initialState = getInitialState();
        set(initialState);
    }, []);
    var genSetter = react_1.useCallback(function (key) { return function (newValue) {
        set(function (prevState) {
            var _a;
            return (__assign(__assign({}, prevState), (_a = {}, _a[key] = newValue, _a)));
        });
        var attr = config[key];
        if (typeof attr === "string") {
            $root.style.setProperty(attr, newValue);
        }
        else {
            $root.style.setProperty(attr.key, newValue);
        }
    }; }, []);
    var schema = {};
    entries.forEach(function (_a) {
        var key = _a[0];
        schema[key] = [state[key], genSetter(key)];
    });
    return schema;
};
exports.default = exports.useSelectorState;
//# sourceMappingURL=useSelectorState.js.map